package com.edu.jsf.bsp.tag;

import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;

/**
 * Komponentenklasse fr die Usage-Komponente.
 * 
 * (Copyright Bosch, Andy - JavaServer Faces - ISBN: 3-8273-2127-1)
 */
public class UIUsageBar extends UIComponentBase {
	/** Prozentwert */
	Integer inuse = null;
	
	/** Familienbezeichner */
	public static final String COMPONENT_FAMILY = "Graph";
	
	/**
	 * Liefert einen Bezeichner fr die 
	 * Komponentenfamilie zurck.
	 */
	public String getFamily() {
		return( COMPONENT_FAMILY );
	}

	/**
	 * 
	 * @return
	 */
	public Integer getInuse() {
		ValueBinding vB = this.getValueBinding("inuse");
		//value bindung reference
		if (vB != null) {
			System.out.println("!!!VALUEBINDING" + vB);
		System.out.println(vB.getExpressionString());
		System.out.println(vB.getValue(FacesContext.getCurrentInstance()));
		//return new Integer(10);
		inuse = (Integer) vB.getValue(FacesContext.getCurrentInstance());
		return inuse;
					
		//or direct access
		}
		else{
			System.out.println("!!!DIREKTWERT" + inuse);
			return inuse;
		}
	}
	
	public void setInuse(Integer inuse) {
		this.inuse = inuse;
	}

	public Object saveState(FacesContext context) {
		Object values[] = new Object[2];
		values[0] = super.saveState(context);
		values[1] = inuse;
		return (values);
	}

	public void restoreState(FacesContext context, Object state) {
		Object values[] = (Object[]) state;
		super.restoreState(context, values[0]);
		inuse = (Integer)values[1];
	}
}
