package com.edu.jsf.bsp.tag;

import java.io.IOException;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.render.Renderer;

import util.message.CleverMessageFactory;

/**
 * Rendererklasse fr die Usagebar-Komponente.
 * (Copyright Bosch, Andy - JavaServer Faces - ISBN: 3-8273-2127-1)
 */
public class UsageBarRenderer extends Renderer {
	/** Id und Meldungstext fr 'Verbrauch' */
	public static final String USAGE_OUT_ID = "usageBar_txt"; 
	public static final String USAGE_OUT_TXT = "Usage"; 
	
	private int total_length	= 100;
	
	/**
	 * Decodierung
	 */
	public void decode(FacesContext context, UIComponent component) {
	}

	/**
	 * Codierung
	 */
	public void encodeBegin( FacesContext context, UIComponent component )
		throws IOException {
			String outMsg = CleverMessageFactory.getMessage(USAGE_OUT_ID, USAGE_OUT_TXT).getDetail();
		
			ResponseWriter writer = context.getResponseWriter();
			
			UIUsageBar uibar = (UIUsageBar)component;
			
			int red_length =  total_length / 100 * uibar.getInuse().intValue();
			int grey_length = total_length - red_length;
			
			writer.write("<table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">");
			writer.write("<tr>");
			writer.write("<td height=\"10\" bgcolor=\"#FF5807\"><img src=\".\\image\\usagebar_space.gif\" width=\"" + red_length + "\" height=\"10\" border=\"0\" alt=\"\"></td>");
			writer.write("<td height=\"10\" bgcolor=\"#C0C0C0\"><img src=\".\\image\\usagebar_space.gif\" width=\"" + grey_length + "\" height=\"10\" border=\"0\" alt=\"\"></td>");
			writer.write("</tr>");
			writer.write("<tr><td colspan=\"2\"><font size=\"2\">");
			writer.write(outMsg);
			writer.write(" " + uibar.getInuse() + "%</font></td></tr>");
			writer.write("</table>");
	}

	public void encodeChildren(FacesContext arg0, UIComponent arg1)
		throws IOException {
	}

	public void encodeEnd(FacesContext arg0, UIComponent arg1)
		throws IOException {
	}


}
