package com.edu.jsf.bsp.tag;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;
import javax.faces.webapp.UIComponentTag;

/**
 * Tag-Klasse fr die UsageBar-Komponente.
 * Diese zeigt einen Verbrauchsbalken in Abhngigkeit
 * der bergebenen Prozentzahl.
 * 
 * (Copyright Bosch, Andy - JavaServer Faces - ISBN: 3-8273-2127-1)
 */
public class UsageBarTag extends UIComponentTag {
	/** Renderertyp */
	public static final String RENDERER_TYPE = "UsageBar";
	/** Komponententyp */
	public static final String COMPONENT_TYPE = "UsageBar";

	private String inuse;
	
	/*
	 * Liefert den Renderer zurck.
	 */
	public String getRendererType() {
		return "UsageBar";
	}

	/*
	 * Liefert den Komponententyp zurck.
	 * Eine entsprechende Eintragung dazu ist ind
	 * der faces-config.xml zu finden.
	 */
	public String getComponentType() {
		return "UsageBar";
	}

	/*
	 * Gibt alle Ressourcen frei.
	 */
	public void release() {
	  super.release();
	}

	/*
	 * Setzt die Properties in die Komponente.
	 */
	protected void setProperties(UIComponent component) {
		super.setProperties(component);
		UIUsageBar usageBarComp = (UIUsageBar) component;
		if (UIComponentTag.isValueReference(inuse)) {
			ValueBinding vb = 
				FacesContext.getCurrentInstance().getApplication().createValueBinding(inuse);
            usageBarComp.setValueBinding("inuse", vb);
        }
		else
			usageBarComp.setInuse(new Integer(inuse));
	}

	public String getInuse() {
		return inuse;
	}

	public void setInuse(String inuse) {
		this.inuse = inuse;
	}

}
