/**
 * 
 */
package sf.controller;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import sf.modell.Member;

/**
 * Verwaltet die TeilnehmerListe
 * 
 * @author Danny
 *
 */
public class MemberController {
	/** neu // editieren */
	private static final String OUTCOME_EDIT = "ta_member_edit";
	/** lschen */
	private static final String OUTCOME_LIST = "ta_member";

	/** Anzahl an Eintrgen pro Seite */
	private static final int PER_PAGE = 20;
	
	/** Anzeigepostion */
	private int pos;
	
	private boolean notFirstPage;
	private boolean notLastPage;
	
	/** zu editierender Teilnehmer */
	private Member currentMember;
	/** just a hack *** keine ids vorhanden - daher notwendig um edit und new zu unterscheiden*/
	private boolean isNew;
	
	/** enthlt alle teilnehmer fr die datatable */
	private List<MemberRow> memberRows = new ArrayList<MemberRow>();
	
	private void simulateDB() {
		Member t = new Member(); t.setEmail("wi2021@fh-wedel.de"); t.setFirstName("Philip"); t.setName("Chinery"); 
		MemberRow z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("wi4251@fh-wedel.de");	t.setFirstName("Nils"); t.setName("Paulussen");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("wi5186@fh-wedel.de");	t.setFirstName("Philipp"); t.setName("Guzielski");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("wi5270@fh-wedel.de");	t.setFirstName("Danny"); t.setName("Falss");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("wi5664@fh-wedel.de");	t.setFirstName("Jan-Peter"); t.setName("Wohlers");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("winf2617@fh-wedel.de");	t.setFirstName("Thomas"); t.setName("Kresalek");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("inf2421@fh-wedel.de");	t.setFirstName("Wolfgang"); t.setName("Schmoller");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("inf2432@fh-wedel.de");	t.setFirstName("Frederic"); t.setName("Schmaljohann");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("inf2455@fh-wedel.de");	t.setFirstName("Sebastian"); t.setName("Hempel");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("inf2584@fh-wedel.de");	t.setFirstName("Johannes"); t.setName("Barop");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("inf2788@fh-wedel.de");	t.setFirstName("Claudia"); t.setName("Schuster");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("inf8237@fh-wedel.de");	t.setFirstName("Sven"); t.setName("Urbanski");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("mi4924@fh-wedel.de");	t.setFirstName("Tim"); t.setName("Baumgarten");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("minf2434@fh-wedel.de");	t.setFirstName("Markus"); t.setName("Knofe");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		t = new Member(); t.setEmail("minf2622@fh-wedel.de");	t.setFirstName("Alexander"); t.setName("Treptow");
		z = new MemberRow(); z.setSelected(false); z.setMember(t); memberRows.add(z);
		Collections.sort(memberRows);
	}
	
	private void checkFirstPage() {
		notFirstPage = pos >= PER_PAGE;
	}
	
	private void checkLastPage() {
		notLastPage = (pos + PER_PAGE) <= memberRows.size();
	}
	
	public MemberController() {
		simulateDB();
		
		pos = 0;
		checkFirstPage();
		checkLastPage();
	}
	
	/** 
	 * erstellt einen neuen (leeren) teilnehmer
	 */
	public String addMember() {
		isNew = true;
		currentMember = new Member();
		return OUTCOME_EDIT;
	}
	
	/** 
	 * editiert (ersten) ausgewhlten teilnehmer der aktuellen seite
	 */
	public String editMember() {
		isNew = false;
		currentMember = null;
		for (int i=pos; i < Math.min(pos + PER_PAGE, memberRows.size()) ; i++)
			if (memberRows.get(i).isSelected()) {
				currentMember = memberRows.get(i).getMember(); 
				break;
			}
		if (currentMember == null)
			addMember();
		
		return OUTCOME_EDIT;
	}

	/**
	 * Lscht alle ausgewhlten Teilnehmer
	 * @return
	 */
	public String update() {
		//ist er neu dann anhngen
		if (isNew) {
			//also an die liste anfgen
			MemberRow _new = new MemberRow();
			_new.setMember(currentMember);
			memberRows.add(_new);
		}
		
		//neu sortieren
		Collections.sort(memberRows);
		
		return OUTCOME_LIST;
	}
	
	/**
	 * Lscht alle ausgewhlten Teilnehmer
	 * @return
	 */
	public String deleteMembers() {
		//von anfang der aktuellen seite bis seitenende bzw. datenende suchen
		for (int i=pos; i < Math.min(pos + PER_PAGE, memberRows.size()) ; i++)
			//ausgewhlt?
			if (memberRows.get(i).isSelected()) {
				//dann lschen
				memberRows.remove(i);
				//ein element weniger in der liste, zeiger runtersetzen
				i-=1;
			}
		
		return OUTCOME_LIST;
	}
	
	/**
	 * @return the pER_PAGE
	 */
	public int getPER_PAGE() {
		return PER_PAGE;
	}

	/**
	 * @param per_page the pER_PAGE to set
	public void setPER_PAGE(int per_page) {
	}
	 */

	/**
	 * @return the pos
	 */
	public int getPos() {
		return pos;
	}

	/**
	 * @param pos the pos to set
	 */
	public void setPos(int pos) {
		this.pos = pos;
	}
	
	public void backward(ActionEvent e) {
		pos -= PER_PAGE;
		if (pos < 0) 
			pos = 0;
		checkFirstPage();
	}

	public void topage(ActionEvent e) {
		int pageNo = Integer.parseInt(((String) e.getComponent().findComponent("abc").getAttributes().get("page")));
		pos = pageNo * PER_PAGE; 
		checkFirstPage();
		checkLastPage();
	}

	public void forward(ActionEvent e) {
		pos += PER_PAGE;
		if (pos > memberRows.size())
			pos = memberRows.size();
		checkLastPage();
	}
	
	/**
	 * @return the notFirstPage
	 */
	public boolean isNotFirstPage() {
		checkFirstPage();
		return notFirstPage;
	}

	/**
	 * @param notFirstPage the notFirstPage to set
	 */
	public void setNotFirstPage(boolean notFirstPage) {
		this.notFirstPage = notFirstPage;
	}

	/**
	 * @return the notLastPage
	 */
	public boolean isNotLastPage() {
		checkLastPage();
		return notLastPage;
	}

	/**
	 * @param notLast the notLast to set
	 */
	public void setNotLastPage(boolean notLastPage) {
		this.notLastPage = notLastPage;
	}

	/**
	 * @return the memberRows
	 */
	public List<MemberRow> getMemberRows() {
		return memberRows;
	}

	/**
	 * @param memberRows the memberRows to set
	 */
	public void setMemberRows(List<MemberRow> memberRows) {
		this.memberRows = memberRows;
	}

	/**
	 * @return the currentMember
	 */
	public Member getCurrentMember() {
		return currentMember;
	}

	/**
	 * @param currentMember the currentMember to set
	 */
	public void setCurrentMember(Member currentMember) {
		this.currentMember = currentMember;
	}

	public void validateEmail(FacesContext context, 
            UIComponent toValidate,
            Object value) {
		
		String email = (String) value;
		
		//kein @ zeichen
		if (email.indexOf('@') == -1) {
			((UIInput)toValidate).setValid(false);

			//lokalisierte meldung holen
			ResourceBundle bundle = null;
			String msg = "Invalid Email";
			try {
				bundle = ResourceBundle.getBundle("sf.resource.msg", context.getViewRoot().getLocale());
				//text auslesen
				msg = bundle.getString("validation_email");
			}
			catch (Exception e) {
			}
			
			//meldung erzeugen
			FacesMessage message = new FacesMessage(msg, msg);
			//eintragen
			context.addMessage(toValidate.getClientId(context), message);
		}

	}
}
