/**
 * 
 */
package sf.modell;

/**
 * Die Abbildung eines Teilnehmers fr ein Seminar
 * 
 * @author Danny
 */
public class Member implements Comparable<Member> {
	private String name;
	private String firstName;
	private String email;
	
	/**
	 * @return the firstName
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * @param firstName the firstName to set
	 */
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	/**
	 * @return the email
	 */
	public String getEmail() {
		return email;
	}

	/**
	 * @param mail the mail to set
	 */
	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Vergleichsoperation
	 * Reihenfolge: nachname -> vorname -> email (sensitiv)
	 */
	public int compareTo(Member m) {
		if (name.equals(m.name))
			if (firstName.equals(m.firstName))
				return email.compareTo(m.email);
			else
				return firstName.compareTo(m.firstName);

		return name.compareTo(m.name);
	}
	
	/**
	 * Gleichheitstest
	 */
	public boolean equals(Object o) {
		if (o instanceof Member) {
			Member m = (Member) o;
			return name.equals(m.name) && firstName.equals(m.firstName) && email.equals(m.email);
		}
		
		return false;
	}
	
	/**
	 * Destructor
	 */
	protected void finalize() throws Throwable {
		name = null;
		firstName = null;
		email = null;
		super.finalize();
	}
}
