/**
 */
package sf.modell;

/**
 * Reprsentiert ein Thema, das als Seminar belegt werden kann
 *
 * @author Danny
 */
public class Subject implements Comparable<Subject> {
	/** zhlt die Anzahl der existierenden Objekte */
	private static int Counter = 0; 
	
	private Integer no;
	private String text;
	
	/**
	 * Konstruktor
	 */
	public Subject() {
		Counter++;
		no = new Integer(Counter);
	}
	
	/**
	 * @return the no
	 */
	public Integer getNo() {
		return no;
	}

	/**
	 * @param no the no to set
	 */
	public void setNo(Integer no) {
		this.no = no;
	}

	/**
	 * @return the text
	 */
	public String getText() {
		return text;
	}

	/**
	 * @param text the text to set
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * Vergleichsoperation
	 */
	public int compareTo(Subject s) {
		if (no.equals(s.no))
			return text.compareTo(s.text);

		return no.compareTo(s.no);
	}
	
	/**
	 * Gleichheitstest
	 */
	public boolean equals(Object o) {
		if (o instanceof Subject) {
			Subject s = (Subject) o;
			return no.equals(s.no) && text.equals(s.text);
		}
		return false;
	}
	
	/**
	 * Destructor
	 */
	protected void finalize() throws Throwable {
		Counter--;
		no = null; 
		text = null;
		super.finalize();
	}

}
