/**
 * 
 */
package sf.modell;

import java.util.Date;

/**
 * Reprsentiert die Verbindung zwischen einem Thema und mindestens einem Teilnehmer
 * @author Danny
 *
 */
public class Tutorial implements Comparable<Tutorial> {
	/** Tag und Zeit des Vortrags */
	private Date date = new Date();
	/** das thema */
	private Subject subject;
	/** referent */
	private Member member;


	public Member getMember() {
		return member;
	}
	public void setMember(Member member) {
		this.member = member;
	}
	/**
	 * @return the subject
	 */
	public Subject getSubject() {
		return subject;
	}
	/**
	 * @param subject the subject to set
	 */
	public void setSubject(Subject subject) {
		this.subject = subject;
	}
	
	/**
	 * Vergleichsoperation
	 */
	public int compareTo(Tutorial t) {
		if (date.equals(t.date))
			if (member.equals(t.member))
				return subject.compareTo(t.subject);
			else
				return member.compareTo(t.member);
		
		return date.compareTo(t.date);
	}
	
	/**
	 * Gleichheitstest
	 */
	public boolean equals(Object o) {
		if (o instanceof Tutorial) {
			Tutorial t = (Tutorial) o;
			return date.equals(t.date) && subject.equals(t.subject) && member.equals(t.member);
		}
		return false;
	}
	
	/**
	 * Destructor
	 */
	protected void finalize() throws Throwable {
		date = null;
		subject = null;
		member = null;
		super.finalize();
	}
	/**
	 * @return the date
	 */
	public Date getDate() {
		return date;
	}
	/**
	 * @param date the date to set
	 */
	public void setDate(Date date) {
		this.date = date;
	}

}
