package util.listener;

import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

/**
 * Wird vor und nach jeder Phase des Lifecycles aufgerufen
 * 
 * @author Danny
 */
public class AllPhaseListener implements PhaseListener {
	static final long serialVersionUID = 1234567890;
	
	/**
	 * wird vor jeder Phase ausgefhrt 
	 */
	public void beforePhase(PhaseEvent pE) {
		System.out.println(getClass().getSimpleName() + ".beforePhase: " + pE.getPhaseId());
	}

	/**
	 * wird nach jeder Phase ausgefhrt 
	 */
	public void afterPhase(PhaseEvent pE) {
		System.out.println(getClass().getSimpleName() + ".afterPhase: " + pE.getPhaseId());
	}

	/**
	 * aktiv fr eine bestimmte oder alle Phasen
	 */
	public PhaseId getPhaseId() {
		//PhaseId.RESTORE_VIEW;
		//PhaseId.APPLY_REQUEST_VALUES;
		//PhaseId.PROCESS_VALIDATIONS;
		//PhaseId.UPDATE_MODEL_VALUES;
		//PhaseId.INVOKE_APPLICATION;
		//PhaseId.RENDER_RESPONSE;
		//PhaseId.APPLY_REQUEST_VALUES;
		return PhaseId.ANY_PHASE;
	}

}
