/**
 * 
 */
package util.message;

import javax.faces.application.FacesMessage;

import com.sun.faces.util.MessageFactory;

/**
 * Sucht nach lokalisierten Meldungen oder verwendet eoemm standard text  
 * @author Danny
 *
 */
public class CleverMessageFactory {

	/**
	 * Erstellt eine meldung aus dem bundle oder verwendet einen standardtext, wenn meldung nicht im bundle vorhanden ist.
	 * @param id name der meldung im bundle
	 * @param msg alternativer defaulttext falls meldung nicht im bundle
	 * @return FacesMessage- generierte meldung
	 */
	public static FacesMessage getMessage(String id, String msg) {
		Object[] _null=null;
		return getMessage(id, _null, msg);
	}

	/**
	 * Erstellt eine meldung aus dem bundle oder verwendet einen standardtext, wenn meldung nicht im bundle vorhanden ist.
	 * @param id name der meldung im bundle
	 * @param arg paramter die in meldung eingefgt werden
	 * @param msg alternativer defaulttext falls meldung nicht im bundle
	 * @return FacesMessage- generierte meldung
	 */
	public static FacesMessage getMessage(String id, String arg, String msg) {
		return getMessage(id, new Object[] {arg}, msg);
	}

	/**
	 * Erstellt eine meldung aus dem bundle oder verwendet einen standardtext, wenn meldung nicht im bundle vorhanden ist.
	 * @param id name der meldung im bundle
	 * @param args paramter die in meldung eingefgt werden
	 * @param msg alternativer defaulttext falls meldung nicht im bundle
	 * @return FacesMessage- generierte meldung
	 */
	public static FacesMessage getMessage(String id, Object[] args, String msg) {
		//lokalisierte meldung holen
		FacesMessage message = 
			MessageFactory.getMessage(id, args);
		//prfen ob meldung geladen wurde
		if (message == null || message.getDetail() == null)
			//wenn nicht, dann default erzeugen
			message = new FacesMessage(msg, msg);
		
		return message;
	}
}
