package util.validator;

import java.util.Date;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import util.message.CleverMessageFactory;

public class DateNotInPast implements Validator {
	/** Name des Fehlertextes */
	public static final String INVALID_MSG_ID = "validation_dateNotInPast";
	/** Std. Fehlertext */
	public static final String INVALID_MSG_TXT = "Given Date is in the past";

	public void validate(FacesContext context, UIComponent component, Object object)
			throws ValidatorException {
		
		//context und/oder komponente nicht angegeben
		if (context == null || component == null )
			throw new NullPointerException();
		
		//kein Datum angegeben
		if (!(object instanceof Date))
			throw new ClassCastException();
		
		Date date = (Date) object;
		Date today = new Date();
		today.setHours(0); today.setMinutes(0); today.setSeconds(0);
		
		if (date == null || date.before(today))
			//validierungsfehler werfen
			throw new ValidatorException(
				CleverMessageFactory.getMessage(INVALID_MSG_ID, INVALID_MSG_TXT)
			);
	}

}
