/**
 * 
 */
package util.validator;

import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import util.message.CleverMessageFactory;

/**
 * berprft eine emailadresse auf gltigkeit
 * 
 * @author Danny
 *
 */
public class Mail implements Validator {
	/** Name des Fehlertextes */
	public static final String INVALID_MSG_ID = "validation_email";
	/** Std. Fehlertext */
	public static final String INVALID_MSG_TXT = "Invalid emailadress: missing '@'";
	
	public void validate(FacesContext context, UIComponent component, Object value)
			throws ValidatorException {
		
		//context und/oder komponente nicht angegeben
		if (context == null || component == null )
			throw new NullPointerException();
		
		//validierung nur fr textfelder
		if (!(component instanceof UIInput))
			return;
		
		String email = (String) value;
		
		//auf @ zeichen prfen
		if (email.indexOf('@') == -1) {
			//ungltig markieren
			((UIInput)component).setValid(false);
			
			//validierungsfehler werfen
			throw new ValidatorException(
				CleverMessageFactory.getMessage(INVALID_MSG_ID, INVALID_MSG_TXT)
			);
		}
	
		//vom gelingen ausgehend
		((UIInput)component).setValid(true);
	
	}

}
